Package org.eclipse.m2m.atl.emftvm.util

# Class LazyOrderedSet.PrependOrderedSet.PrependOrderedSetListIterator

java.lang.Object
org.eclipse.m2m.atl.emftvm.util.LazyCollection.ReadOnlyIterator<E>
org.eclipse.m2m.atl.emftvm.util.LazyCollection.ReadOnlyListIterator<E>
LazyCollection<E>.org.eclipse.m2m.atl.emftvm.util.LazyCollection.WrappedListIterator
org.eclipse.m2m.atl.emftvm.util.LazyOrderedSet.PrependOrderedSet.PrependOrderedSetListIterator

All Implemented Interfaces:
  `Iterator<E>`, `ListIterator<E>`

Enclosing class:
  `LazyOrderedSet.PrependOrderedSet<E>`

public class LazyOrderedSet.PrependOrderedSet.PrependOrderedSetListIterator extends LazyCollection<E>.WrappedListIterator
`Iterator` that appends an object to the underlying collection, except when it already occurs in the underlying collection.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`beforeHead`
`protected boolean`
`innerPrev`

### Fields inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection.WrappedListIterator

`inner`

## Constructor Summary

Constructors
Constructor
Description
`PrependOrderedSetListIterator()`
Creates a new `LazyOrderedSet.PrependOrderedSet<E>.PrependOrderedSetListIterator`.
`PrependOrderedSetListIterator(int index)`
Creates a new `LazyOrderedSet.PrependOrderedSet<E>.PrependOrderedSetListIterator`.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`hasNext()`
`boolean`
`hasPrevious()`
`E`
`next()`
`int`
`nextIndex()`
`E`
`previous()`
`int`
`previousIndex()`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection.ReadOnlyListIterator

`add, set`

### Methods inherited from class org.eclipse.m2m.atl.emftvm.util.LazyCollection.ReadOnlyIterator

`remove`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.util.Iterator

`forEachRemaining`

### Methods inherited from interface java.util.ListIterator

`remove`

## Field Details

### beforeHead

protected boolean beforeHead

### innerPrev

protected boolean innerPrev

## Constructor Details

### PrependOrderedSetListIterator

public PrependOrderedSetListIterator()
Creates a new `LazyOrderedSet.PrependOrderedSet<E>.PrependOrderedSetListIterator`.

### PrependOrderedSetListIterator

public PrependOrderedSetListIterator(int index)
Creates a new `LazyOrderedSet.PrependOrderedSet<E>.PrependOrderedSetListIterator`.

Parameters:
  `index` - the iterator starting index.

## Method Details

### hasNext

public boolean hasNext()

Specified by:
  `hasNext` in interface `Iterator<E>`
Specified by:
  `hasNext` in interface `ListIterator<E>`
Overrides:
  `hasNext` in class `LazyCollection<E>.WrappedListIterator`

### next

public E next()

Specified by:
  `next` in interface `Iterator<E>`
Specified by:
  `next` in interface `ListIterator<E>`
Overrides:
  `next` in class `LazyCollection<E>.WrappedListIterator`

### nextIndex

public int nextIndex()

Specified by:
  `nextIndex` in interface `ListIterator<E>`
Overrides:
  `nextIndex` in class `LazyCollection<E>.WrappedListIterator`

### hasPrevious

public boolean hasPrevious()

Specified by:
  `hasPrevious` in interface `ListIterator<E>`
Overrides:
  `hasPrevious` in class `LazyCollection<E>.WrappedListIterator`

### previous

public E previous()

Specified by:
  `previous` in interface `ListIterator<E>`
Overrides:
  `previous` in class `LazyCollection<E>.WrappedListIterator`

### previousIndex

public int previousIndex()

Specified by:
  `previousIndex` in interface `ListIterator<E>`
Overrides:
  `previousIndex` in class `LazyCollection<E>.WrappedListIterator`